/***************************************************************************
    nullchan.h

    Copyright (c) 2002-2003  Vladimir Toncar

    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/

    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
    See the License for the specific language governing rights and
    limitations under the License.

    The Original Code is oh323tut.

    The Initial Developer of the Original Code is Vladimir Toncar.
    All Rights Reserved.

    Contributor(s): ______________________________________.

 ***************************************************************************/

#ifndef _NULLCHAN_H
#define _NULLCHAN_H

#include <ptlib.h>
#include <h323.h>
#include <ptclib/pwavfile.h>
#include <ptclib/delaychan.h>
#include <ptlib/sound.h>


// ***********************************************************************

class NullChannel: public PSoundChannel
{
  PCLASSINFO(NullChannel, PSoundChannel);

public:
	NullChannel();
	~NullChannel();

	virtual BOOL Close(); 
	virtual BOOL IsOpen() const { return isOpen; };
	virtual BOOL Read(void *buf, PINDEX len);
	virtual BOOL Write(const void *buf, PINDEX len); 

 protected:
	PAdaptiveDelay writeDelay;
	PAdaptiveDelay readDelay;
	bool isOpen;
};


#endif

